package cn.iocoder.yudao.module.erp.service.autocode;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.erp.controller.admin.autocode.vo.*;
import cn.iocoder.yudao.module.erp.dal.dataobject.autocode.AutocodePartDO;
import cn.iocoder.yudao.module.erp.dal.mysql.autocode.AutocodePartMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import javax.annotation.Resource;

import static cn.iocoder.yudao.module.erp.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link AutocodePartServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(AutocodePartServiceImpl.class)
public class AutocodePartServiceImplTest extends BaseDbUnitTest {

    @Resource
    private AutocodePartServiceImpl autocodePartService;

    @Resource
    private AutocodePartMapper autocodePartMapper;

    @Test
    public void testCreateAutocodePart_success() {
        // 准备参数
        AutocodePartSaveReqVO createReqVO = randomPojo(AutocodePartSaveReqVO.class).setId(null);

        // 调用
        Long autocodePartId = autocodePartService.createAutocodePart(createReqVO);
        // 断言
        assertNotNull(autocodePartId);
        // 校验记录的属性是否正确
        AutocodePartDO autocodePart = autocodePartMapper.selectById(autocodePartId);
        assertPojoEquals(createReqVO, autocodePart, "id");
    }

    @Test
    public void testUpdateAutocodePart_success() {
        // mock 数据
        AutocodePartDO dbAutocodePart = randomPojo(AutocodePartDO.class);
        autocodePartMapper.insert(dbAutocodePart);// @Sql: 先插入出一条存在的数据
        // 准备参数
        AutocodePartSaveReqVO updateReqVO = randomPojo(AutocodePartSaveReqVO.class, o -> {
            o.setId(dbAutocodePart.getId()); // 设置更新的 ID
        });

        // 调用
        autocodePartService.updateAutocodePart(updateReqVO);
        // 校验是否更新正确
        AutocodePartDO autocodePart = autocodePartMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, autocodePart);
    }

    @Test
    public void testUpdateAutocodePart_notExists() {
        // 准备参数
        AutocodePartSaveReqVO updateReqVO = randomPojo(AutocodePartSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> autocodePartService.updateAutocodePart(updateReqVO), AUTOCODE_PART_NOT_EXISTS);
    }

    @Test
    public void testDeleteAutocodePart_success() {
        // mock 数据
        AutocodePartDO dbAutocodePart = randomPojo(AutocodePartDO.class);
        autocodePartMapper.insert(dbAutocodePart);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbAutocodePart.getId();

        // 调用
        autocodePartService.deleteAutocodePart(id);
       // 校验数据不存在了
       assertNull(autocodePartMapper.selectById(id));
    }

    @Test
    public void testDeleteAutocodePart_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> autocodePartService.deleteAutocodePart(id), AUTOCODE_PART_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetAutocodePartPage() {
       // mock 数据
       AutocodePartDO dbAutocodePart = randomPojo(AutocodePartDO.class, o -> { // 等会查询到
           o.setRuleId(null);
           o.setPartIndex(null);
           o.setPartType(null);
           o.setPartCode(null);
           o.setPartName(null);
           o.setPartLength(null);
           o.setDatetimeFormat(null);
           o.setInputCharacter(null);
           o.setFixCharacter(null);
           o.setSeriaStartNo(null);
           o.setSeriaStep(null);
           o.setSeriaNowNo(null);
           o.setCycleFlag(null);
           o.setCycleMethod(null);
           o.setRemark(null);
           o.setIsEnable(null);
           o.setCreateTime(null);
       });
       autocodePartMapper.insert(dbAutocodePart);
       // 测试 ruleId 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setRuleId(null)));
       // 测试 partIndex 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setPartIndex(null)));
       // 测试 partType 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setPartType(null)));
       // 测试 partCode 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setPartCode(null)));
       // 测试 partName 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setPartName(null)));
       // 测试 partLength 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setPartLength(null)));
       // 测试 datetimeFormat 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setDatetimeFormat(null)));
       // 测试 inputCharacter 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setInputCharacter(null)));
       // 测试 fixCharacter 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setFixCharacter(null)));
       // 测试 seriaStartNo 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setSeriaStartNo(null)));
       // 测试 seriaStep 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setSeriaStep(null)));
       // 测试 seriaNowNo 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setSeriaNowNo(null)));
       // 测试 cycleFlag 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setCycleFlag(null)));
       // 测试 cycleMethod 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setCycleMethod(null)));
       // 测试 remark 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setRemark(null)));
       // 测试 isEnable 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setIsEnable(null)));
       // 测试 createTime 不匹配
       autocodePartMapper.insert(cloneIgnoreId(dbAutocodePart, o -> o.setCreateTime(null)));
       // 准备参数
       AutocodePartPageReqVO reqVO = new AutocodePartPageReqVO();
       reqVO.setRuleId(null);
       reqVO.setPartIndex(null);
       reqVO.setPartType(null);
       reqVO.setPartCode(null);
       reqVO.setPartName(null);
       reqVO.setPartLength(null);
       reqVO.setDatetimeFormat(null);
       reqVO.setInputCharacter(null);
       reqVO.setFixCharacter(null);
       reqVO.setSeriaStartNo(null);
       reqVO.setSeriaStep(null);
       reqVO.setSeriaNowNo(null);
       reqVO.setCycleFlag(null);
       reqVO.setCycleMethod(null);
       reqVO.setRemark(null);
       reqVO.setIsEnable(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<AutocodePartDO> pageResult = autocodePartService.getAutocodePartPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbAutocodePart, pageResult.getList().get(0));
    }

}